/***************************************************************************
 *                                                                         *
 *  Demo fr das EA KIT128-V24 und EA 9719-V24                             *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <math.h>

#define ESC   27
#define NUL    0
#define CR    13
#define LF    10
#define FF    12
#define OFF    0
#define ON     1
#define XMAX 127
#define YMAX  63


FILE *lcd;

/*--------------------------------------------------------------------------
  Routinen zur Ansteuerung des Displays definieren
 ---------------------------------------------------------------------------*/

void clr_lcd()
{ fprintf(lcd, "%c", FF);
}

void warte(int zehntel_sek)
{ fprintf(lcd, "%c%c%c", ESC, '!', zehntel_sek);
}

void cursor(int status)
{ fprintf(lcd, "%c%c%c", ESC, 'C', status);
}

void font(int fontnr)
{ fprintf(lcd, "%c%c%c", ESC, 'F', fontnr);
}

void rahmen(int x1, int y1, int x2, int y2)
{ fprintf(lcd, "%c%c%c%c%c%c", ESC, 'R', x1, y1, x2, y2);
}

void def_bar(int nr, int x1, int y1, int x2, int y2, int aw, int ew)
{ fprintf(lcd, "%c%c%c%c%c%c%c%c%c%c", ESC, '-', 'O', nr, x1, y1, x2, y2, aw, ew);
}

void bar(int nr, int wert)
{ fprintf(lcd, "%c%c%c%c", ESC, '-', nr, wert);
}

void string_out(int x, int y, char *str)
{ fprintf(lcd, "%c%c%c%c", ESC, 'Z', x, y);
  while(*str != NUL)
     fputc(*str++, lcd);
  fputc(NUL, lcd);
}

/*--------------------------------------------------------------------------
  Hauptprogramm
 ---------------------------------------------------------------------------*/

int main()
{
  int barnr, barwert, winkel, x;

  lcd = stdaux;

  puts("\n****************************************************************");
  puts(  "*  Darstellung von 8 Bargraphs auf dem Display als Sinuswelle  *");
  puts(  "*  Anschluss an COM1:                                          *");
  puts(  "*  COM1 mu zuvor initialisiert werden (MODE COM1:12,N,8,2)    *");
  puts(  "****************************************************************");

  clr_lcd();                                     /* Display lschen */
  cursor(OFF);                                   /* Cursor unsichtbar */
  rahmen(0, 0, XMAX, YMAX);                      /* Rechteck zeichnen */
  font(3);                                       /* Zeichensatz 8x16 */
  string_out(8, 1, "EA KIT128 Demo");            /* Zeichenkette ausgeben */

  for(barnr=1; barnr<=8; barnr++)                 /* 8 Bar's definieren */
   { x = (barnr-1)*14 + 9;
     def_bar(barnr, x, 20, x+12, 61, 0, 100);
   }

  puts("\nAbbruch durch Tastendruck");

  winkel = 0;                                    /* Sinuswelle darstellen */
  while(! kbhit())
   { for(barnr = 1; barnr <= 8; barnr++)
      { barwert = 50.0 * (sin((winkel + barnr*30)*3.14/180.0) + 1.0);
	bar(barnr, barwert);                     /* Einen Bargraph zeichnen */
      }
     winkel += 30;  if(winkel >= 360)  winkel = 0;
     warte(1);                                   /* 1/10 s warten */
   }
}

