Program          Demo_fuer_EA_KIT128_und_EA_9719;
Uses    dos,crt;

Var     LCD : File of Byte;
        ESC,NUL,CR,LF,FF,OFF,ON,XMAX,YMAX : Byte;

{*****************************************}
{* Routinen zur Ansteuerung des Displays *}
{*****************************************}

Procedure   Clr_Lcd;
begin
  Write (LCD,FF);
end;

Procedure   Warte(Zehntel_Sek:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('!');
  Write (LCD,ESC,Befehl,Zehntel_Sek);
end;

Procedure   Cursor(Status:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('C');
  Write (LCD,ESC,Befehl,Status);
end;

Procedure   Font(Font_Nr:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('F');
  Write (LCD,ESC,Befehl,Font_Nr);
end;

Procedure   Rahmen(X1,Y1,X2,Y2:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('R');
  Write (LCD,ESC,Befehl,X1,Y1,X2,Y2);
end;

Procedure   Def_Bar(Nr,X1,Y1,X2,Y2,Aw,Ew:Byte);
var    Befehl: Byte;
   Auslenkung: Byte;
begin
  Befehl    := Ord ('-');
  Auslenkung:= Ord ('O');         { nach oben }
  Write (LCD,ESC,Befehl,Auslenkung,Nr,X1,Y1,X2,Y2,Aw,Ew);
end;

Procedure   Bar(Nr,Wert:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('-');
  Write (LCD,ESC,Befehl,Nr,Wert);
end;

Procedure   String_Out(X,Y:Byte;Wort:String);
var    Stelle: Byte;
       Befehl: Byte;
    Buchstabe: Byte;
begin
  Befehl:= Ord ('Z');
  Write (LCD,ESC,Befehl,X,Y);
  For Stelle:=1 to Length(Wort) do begin
    Buchstabe:= Ord(Wort[Stelle]);
    Write (LCD,Buchstabe);
  end;
  Write (LCD,NUL);
end;

{*****************************************************}
{*                                                   *}
{*            H A U P T P R O G R A M M              *}
{*                                                   *}
{*****************************************************}

Var      Bar_Nr,Bar_Wert,x : Byte;
                    Winkel : Integer;
Begin
  ESC := 27;                { Konstanten definieren }
  NUL :=  0;
  CR  := 13;
  LF  := 10;
  FF  := 12;
  OFF :=  0;
  ON  :=  1;
  XMAX:=127;
  YMAX:= 63;

  Assign (LCD,'COM1');
  Rewrite (LCD);

  Writeln ('****************************************************************');
  Writeln ('*  Darstellung von 8 Bargraphs auf dem Display als Sinuswelle  *');
  Writeln ('*  Anschluss an COM1:                                          *');
  Writeln ('*  COM1 mu zuvor initialisiert werden (MODE COM1:12,N,8,2)    *');
  Writeln ('****************************************************************');
  Writeln ('Abbruch per Tastendruck');

  Clr_Lcd;                              { Display lschen }
  Cursor (Off);                         { Cursor unsichtbar }
  Rahmen (0,0,XMAX,YMAX);               { Rechteck zeichnen }
  Font (3);                             { Zeichensatz 8x16 }
  String_Out (8,1,'EA KIT128 Demo');    { Zeichenkette ausgeben }

  For Bar_Nr:=1 to 8 do begin           { 8 Bars definieren }
    X:= (Bar_Nr-1)*14 + 9;
    Def_Bar (Bar_Nr,x,20,x+12,61,0,100);
  end;

  Winkel:= 0;
  Repeat                                { Sinuswelle darstellen }
    For Bar_Nr:= 1 to 8 do begin
      Bar_Wert:= Round(50* (Sin((Winkel+Bar_Nr*30.0)*3.14/180.0) +1.0));
      Bar (Bar_Nr, Bar_Wert);           { Einen Bargraph }
    end;
    Winkel:= Winkel+30; If (Winkel>= 360) then Winkel:= 0;
    Warte (1);                          { 1/10 Sekunde warten }
  until Keypressed;

  Close (LCD);
End.