Program  Demo_fuer_Touchpanel_auf_EA_KIT128;
Uses     dos,crt,ea_io;


Var      ESC,NUL,CR,LF,FF,OFF,ON : Byte;

{*****************************************}
{* Routinen zur Ansteuerung des Displays *}
{*****************************************}


Procedure   Clr_Lcd;
begin
  IO_WriteByte(FF);                 { Form Feed }
end;

Procedure   Cursor(Status:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('C');
  IO_WriteByte(ESC);
  IO_WriteByte(Befehl);
  IO_WriteByte(Status);
end;

Procedure   Font(Font_Nr:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('F');
  IO_WriteByte(ESC);
  IO_WriteByte(Befehl);
  IO_WriteByte(Font_Nr);
end;

Procedure   String_Out(X,Y:Byte;Wort:String);
var    Stelle: Byte;
       Befehl: Byte;
    Buchstabe: Byte;
begin
  Befehl:= Ord ('Z');
  IO_WriteByte(ESC);
  IO_WriteByte(Befehl);
  IO_WriteByte(X);
  IO_WriteByte(Y);
  For Stelle:=1 to Length(Wort) do begin
    Buchstabe:= Ord(Wort[Stelle]);
    IO_WriteByte(Buchstabe);
  end;
  IO_WriteByte(NUL);
end;

Procedure   Touch_Clr;
var    Befehl: Byte;
begin
  Befehl:= Ord ('*');
  IO_WriteByte(ESC);
  IO_WriteByte(Befehl);
  IO_WriteByte(1);                  { Feld Nummer 1 bis 32 }
  IO_WriteByte(32);
  IO_WriteByte(0);                  { deaktivieren }
  IO_WriteByte(0);                  { kein Rahmen }
  IO_WriteByte(0);                  { keine Beschriftung }
end;

Procedure   Touch_Def(Feld1,Feld2,RetCode,Form:Byte;Wort:String);
var    Stelle: Byte;
       Befehl: Byte;
    Buchstabe: Byte;
begin
  Befehl:= Ord ('*');
  IO_WriteByte(ESC);
  IO_WriteByte(Befehl);
  IO_WriteByte(Feld1);
  IO_WriteByte(Feld2);
  IO_WriteByte(RetCode);
  IO_WriteByte(Form);
  IO_WriteByte(1);                   { 1 Textzeile als Beschriftung }
  For Stelle:=1 to Length(Wort) do begin
    Buchstabe:= Ord(Wort[Stelle]);
    IO_WriteByte(Buchstabe);
  end;
  IO_WriteByte(NUL);                 { Endekennung fr die Beschriftung }
end;

Procedure   Touch_Reaktion(Buchstabe:Char);
var    Befehl: Byte;

begin
  Befehl:= Ord ('*');
  IO_WriteByte(ESC);
  IO_WriteByte(Befehl);
  IO_Write(Buchstabe);               { erlaubt sind A..D }
end;

Procedure    Schalter_lesen;
var           Baudrate: String;
         Schnittstelle: String;

begin
  If ParamCount <> 0 then begin
    For i:=1 to ParamCount do begin
      If ParamStr(i) =     '1' then Schnittstelle:= 'COM1';
      If ParamStr(i) =     '2' then Schnittstelle:= 'COM2';
      If ParamStr(i) =   '300' then      Baudrate:= '300';
      If ParamStr(i) =  '1200' then      Baudrate:= '1200';
      If ParamStr(i) =  '2400' then      Baudrate:= '2400';
      If ParamStr(i) =  '4800' then      Baudrate:= '4800';
      If ParamStr(i) =  '9600' then      Baudrate:= '9600';
      If ParamStr(i) = '19200' then      Baudrate:= '19200';
    end;
  end else begin
    Schnittstelle:= 'COM1';
    Baudrate:= '1200';
  end;

  If Schnittstelle = 'COM1' then IO_Ini(COM1,Baudrate); { Schnittstelle des PCs initialisieren }
  If Schnittstelle = 'COM2' then IO_Ini(COM2,Baudrate);
end;


{*****************************************************}
{*                                                   *}
{*            H A U P T P R O G R A M M              *}
{*                                                   *}
{*****************************************************}

Var      Taste : Char;

BEGIN
  ESC := 27;                { Konstanten definieren }
  NUL :=  0;
  CR  := 13;
  LF  := 10;
  FF  := 12;
  OFF :=  0;
  ON  :=  1;

  Schalter_lesen;

  ClrScr;
  Writeln ('****************************************************');
  Writeln ('*                                                  *');
  Writeln ('*                  TOUCH DEMO V1.1                 *');
  Writeln ('*                      13.6.96                     *');
  Writeln ('*                                                  *');
  Writeln ('*  Anschluss an COM1: EA KIT128-V24 auf 1200 Baud  *');
  Writeln ('*   oder z.B. "T_DEMO 2 9600" fr COM2/9600 Baud   *');
  Writeln ('*                                                  *');
  Writeln ('****************************************************');
  Writeln;
  Writeln;

  Clr_Lcd;                              { Display lschen }
  Cursor (Off);                         { Cursor unsichtbar }
  Font (2);                             { Zeichensatz 8x8 }

  String_Out (48,0,'Touch Demo');       { Zeichenkette ausgeben }

  Writeln ('Zuerst werden alle Touchfelder deaktiviert...');
  Touch_Clr;

  Writeln ('dann jedes einzelne Feld aktiviert und mit Rahmen und Beschriftung versehen.');
  Touch_Def ( 1, 1,Ord('1'),2,'1');     { Touch Taste definieren }
  Touch_Def ( 2, 2,Ord('2'),2,'2');
  Touch_Def ( 3, 3,Ord('3'),2,'3');

  Touch_Def ( 9, 9,Ord('4'),2,'4');
  Touch_Def (10,10,Ord('5'),2,'5');
  Touch_Def (11,11,Ord('6'),2,'6');

  Touch_Def (17,17,Ord('7'),2,'7');
  Touch_Def (18,18,Ord('8'),2,'8');
  Touch_Def (19,19,Ord('9'),2,'9');

  Touch_Def (25,27,CR,2,'Ende');

  Touch_Reaktion ('B');                  { Summer aktivieren }
  Touch_Reaktion ('D');                  { Taste invertieren }

  Writeln;
  Writeln;
  Writeln ('Wenn Sie nun die Tasten berhren, wird jeder Code zum PC gesendet:');
  Writeln;

  Taste:=Chr(0);
  Repeat
    If IO_Modeminput then begin
     Taste:= IO_Read;
     Write (Taste);
    end;
  until (Taste=Chr(CR)) or (Keypressed=true);

  Writeln;
  Writeln ('Ende des Demos');
  IO_Close;
End.
